#region Copyright Syncfusion Inc. 2001 - 2005
//
//  Copyright Syncfusion Inc. 2001 - 2005. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Any infringement will be prosecuted under
//  applicable laws. 
//
#endregion

namespace AdvancedTabbedMDI
{
	using System;
	using System.Drawing;
	using System.Collections;
	using System.ComponentModel;
	using System.Windows.Forms;
	using System.Data;

	using Syncfusion.Drawing;
	using Syncfusion.Windows.Forms.Grid;
    using Syncfusion.Windows.Forms;
    using Syncfusion.Windows.Forms.Tools.XPMenus;
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
        private Syncfusion.Windows.Forms.Grid.GridControl gridControl1;
        private IContainer components;
		private GridControl GridA;
		private System.Windows.Forms.Panel panel1;
        private Syncfusion.Windows.Forms.Tools.XPMenus.PopupMenusManager popupMenusManager1;
        private Syncfusion.Windows.Forms.Tools.XPMenus.PopupMenu popupMenu1;
        private Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem parentBarItem1;
        private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem1;
        private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem2;
        private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem3;
		private GridControl GridB;

		public Form1()
		{

			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call

			gridControl1.Rows.DefaultSize = 25;
			gridControl1.Cols.DefaultSize = 120;
			this.gridControl1.TableStyle.VerticalAlignment = GridVerticalAlignment.Middle;

			int rowIndex = 1;
			int colIndex = 1;

			gridControl1[rowIndex, colIndex].Text = "DropDown Grid Cells";
			gridControl1[rowIndex, colIndex].Font.Bold = true;
			gridControl1[rowIndex, colIndex].Font.Size = 10;
			rowIndex++;

			// Notes: uses a derived celltype to embed a dropdowngrid into a cell in another grid
			// the GridDropDownGridCell that ships as part of the library drops an instance of the
			// parent grid. The new derived classes will drop instances of other grids.
			//
			// DropDownGridCellModel derives from GridDropDownGridCellModel and has an override
			// that creates a renderer of the derived DropDownGridCellRenderer. The model also has 
			// a public property of a GridControlBase. It is this property that determines what grid
			// will be shown in the dropdown. So, with this implementation, if you are dropping 4
			// different grids, you will have to create 4 instances of this cell control,  one for each grid.
			//


			// create a couple of child grids to be placed in two dropdowns
            GridA = new GridControl();
			GridA.RowCount = 10;
			GridA.ColCount = 5;
			GridA.ThemesEnabled = true;
			GridA.CausesValidation = false;
            GridA.CellModels.Add("FKCell", new FKCellModelSelectNew(GridA.Model));
            GridA[1, 1].Text = "Popup";
            GridA[1, 1].CellType = "FKCell";
            GridA.CellButtonClicked += new Syncfusion.Windows.Forms.Grid.GridCellButtonClickedEventHandler(this.OnCellButtonClicked);
            

			GridB = new GridControl();
			GridB.RowCount = 6;
			GridB.ColCount = 6;
			GridB.CausesValidation = false;
			GridB.ThemesEnabled = true;
			GridB[1, 1].Text = "Grid B";
            
            // Create and register two dropdown grid cells
			DropDownGridCellModel aModel = new DropDownGridCellModel(this.gridControl1.Model);
			aModel.EmbeddedGrid = GridA;
			DropDownGridCellModel bModel = new DropDownGridCellModel(this.gridControl1.Model);
			bModel.EmbeddedGrid = GridB;
			gridControl1.CellModels.Add("GridADropCell", aModel);
			gridControl1.CellModels.Add("GridBDropCell", bModel);

			gridControl1.ShowCurrentCellBorderBehavior = GridShowCurrentCellBorder.GrayWhenLostFocus;
			gridControl1.ActivateCurrentCellBehavior = GridCellActivateAction.ClickOnCell;

			// set the dropdowns in a couple of cells
			this.gridControl1[rowIndex,1].Text = "Grid A";			
			this.gridControl1[rowIndex,1].CellType = "GridADropCell";
			this.gridControl1[rowIndex,3].Text = "Grid B";			
			this.gridControl1[rowIndex,3].CellType = "GridBDropCell";
			rowIndex += 3;

			gridControl1[rowIndex, colIndex].Text = "DropDown Color Edits";		
			gridControl1[rowIndex, colIndex].Font.Bold = true;
			gridControl1[rowIndex, colIndex].Font.Size = 10;
			rowIndex++;
			gridControl1[rowIndex, colIndex].CellType = "ColorEdit";
			gridControl1[rowIndex, colIndex + 1].CellType = "ColorEdit";
			gridControl1[rowIndex, colIndex + 2].CellType = "ColorEdit";
			gridControl1[rowIndex, colIndex].Text = "LightSteelBlue";
			gridControl1[rowIndex, colIndex + 1].Text = "CornflowerBlue";
			gridControl1[rowIndex, colIndex + 2].Text = "Coral";

			rowIndex += 3;

			gridControl1[rowIndex, colIndex].Text = "DropDown Calendars";
			gridControl1[rowIndex, colIndex].Font.Bold = true;
			gridControl1[rowIndex, colIndex].Font.Size = 10;
			rowIndex++;
			gridControl1[rowIndex, colIndex].CellType = "MonthCalendar";
			gridControl1[rowIndex, colIndex + 1].CellType = "MonthCalendar";
			gridControl1[rowIndex, colIndex + 2].CellType = "MonthCalendar";
			gridControl1[rowIndex, colIndex].CellValue = DateTime.Now;
			gridControl1[rowIndex, colIndex + 1].CellValue = DateTime.Now;
			gridControl1[rowIndex, colIndex + 2].CellValue = DateTime.Now;

			gridControl1.FloatCellsMode = GridFloatCellsMode.BeforeDisplayCalculation;

			this.gridControl1.Properties.GridLineColor = System.Drawing.Color.Silver;
			this.gridControl1.DefaultGridBorderStyle = GridBorderStyle.Solid;

            this.popupMenusManager1.SetXPContextMenu(this.GridB, this.popupMenu1);
            this.popupMenusManager1.SetXPContextMenu(this.GridA, this.popupMenu1);

			this.popupMenusManager1.SetXPContextMenu(this.gridControl1, this.popupMenu1);

			this.popupMenu1.ParentBarItem.Popup += new EventHandler(ParentBarItem_Popup);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            this.gridControl1 = new Syncfusion.Windows.Forms.Grid.GridControl();
            this.panel1 = new System.Windows.Forms.Panel();
            this.popupMenusManager1 = new Syncfusion.Windows.Forms.Tools.XPMenus.PopupMenusManager(this.components);
            this.popupMenu1 = new Syncfusion.Windows.Forms.Tools.XPMenus.PopupMenu(this.components);
            this.parentBarItem1 = new Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem();
            this.barItem1 = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.barItem2 = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.barItem3 = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            ((System.ComponentModel.ISupportInitialize)(this.gridControl1)).BeginInit();
            this.SuspendLayout();
            // 
            // gridControl1
            // 
            this.gridControl1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
            this.gridControl1.ColCount = 15;
            this.gridControl1.HorizontalThumbTrack = true;
            this.gridControl1.Location = new System.Drawing.Point(26, 22);
            this.gridControl1.Name = "gridControl1";
            this.gridControl1.RowCount = 100;
            this.gridControl1.Size = new System.Drawing.Size(536, 313);
            this.gridControl1.SmartSizeBox = false;
            this.gridControl1.TabIndex = 0;
            this.gridControl1.Text = "gridControl1";
            this.gridControl1.ThemesEnabled = true;
            this.gridControl1.VerticalThumbTrack = true;
            this.gridControl1.CurrentCellCloseDropDown += new Syncfusion.Windows.Forms.PopupClosedEventHandler(this.gridControl1_CurrentCellCloseDropDown);
            this.gridControl1.CurrentCellShowedDropDown += new System.EventHandler(this.gridControl1_CurrentCellShowedDropDown);
            // 
            // panel1
            // 
            this.panel1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.panel1.Dock = System.Windows.Forms.DockStyle.Fill;
            this.panel1.Location = new System.Drawing.Point(0, 0);
            this.panel1.Name = "panel1";
            this.panel1.Size = new System.Drawing.Size(624, 398);
            this.panel1.TabIndex = 1;
            // 
            // popupMenusManager1
            // 
            this.popupMenusManager1.ParentForm = this;
            // 
            // popupMenu1
            // 
            this.popupMenu1.ParentBarItem = this.parentBarItem1;
            // 
            // parentBarItem1
            // 
            this.parentBarItem1.CategoryIndex = -1;
            this.parentBarItem1.ID = "";
            this.parentBarItem1.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
            this.barItem1,
            this.barItem2,
            this.barItem3});
            this.parentBarItem1.UpdateUIMFCStyle = true;
            // 
            // barItem1
            // 
            this.barItem1.CategoryIndex = -1;
            this.barItem1.ID = "Item1";
            this.barItem1.Text = "Item1";
            this.barItem1.UpdateUI += new System.EventHandler(this.OnUpdateUI1);
            // 
            // barItem2
            // 
            this.barItem2.CategoryIndex = -1;
            this.barItem2.ID = "Item2";
            this.barItem2.Text = "Item2";
            this.barItem2.UpdateUI += new System.EventHandler(this.OnUpdateUI2);
            // 
            // barItem3
            // 
            this.barItem3.CategoryIndex = -1;
            this.barItem3.ID = "Item3";
            this.barItem3.Text = "Item3";
            this.barItem3.UpdateUI += new System.EventHandler(this.OnUpdateUI3);
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(624, 398);            
            this.Controls.Add(this.gridControl1);
            this.Controls.Add(this.panel1);
            this.Name = "Form1";
            this.Text = "DropdownGrid...";
            this.Load += new System.EventHandler(this.Form1_Load);
            ((System.ComponentModel.ISupportInitialize)(this.gridControl1)).EndInit();
            this.ResumeLayout(false);

		}
		#endregion


        private void OnUpdateUI3(object sender, EventArgs e)
        {
            //((BarItem)sender).Enabled = false;
        }

        private void OnUpdateUI2(object sender, EventArgs e)
        {			
            //((BarItem)sender).Enabled = false;
        }

        private void OnUpdateUI1(object sender, EventArgs e)
        {			
            //((BarItem)sender).Enabled = false;
        }

		bool flag = false;
		private void gridControl1_CurrentCellShowedDropDown(object sender, System.EventArgs e)
		{
			flag = true;
		}

		private void gridControl1_CurrentCellCloseDropDown(object sender, Syncfusion.Windows.Forms.PopupClosedEventArgs e)
		{
			flag = false;			
		}

		private void ParentBarItem_Popup(object sender, EventArgs e)
		{
            this.gridControl1.Focus();
           
            if(flag)
				Console.WriteLine("In DropDown Grid");
			else
				Console.WriteLine("In Parent Grid");
		}
        //GridColSizeHelper colSizeHelper = null;
        private void Form1_Load(object sender, EventArgs e)
        {
            //624, 398
            //if (colSizeHelper == null)
            //{
            //    colSizeHelper = new GridColSizeHelper();
            //    colSizeHelper.WireGrid(this.gridControl1);
            //}

            //// GridColSizeHelper.GridColSizeBehavior behavior = (GridColSizeHelper.GridColSizeBehavior)this.comboBox1.SelectedIndex;
            //colSizeHelper.ColSizeBehavior = GridColSizeHelper.GridColSizeBehavior.FillLeftColumn.EqualProportional;

            //this.gridControl1.Refresh();
        }

        private void OnCellButtonClicked(object sender, GridCellButtonClickedEventArgs e)
        {
            ModalDialog dlg = new ModalDialog();

            if (dlg.ShowDialog(this) == DialogResult.OK)
            {
                // ...
            }
        }
	}
}
