#region Copyright Syncfusion Inc. 2001 - 2005
//
//  Copyright Syncfusion Inc. 2001 - 2005. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Any infringement will be prosecuted under
//  applicable laws. 
//
#endregion

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Windows.Forms.Tools;

namespace AdvancedTabbedMDI
{
	/// <summary>
	/// Summary description for MainForm.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Splitter splitter1;
        private System.Windows.Forms.Panel panel1;
        private System.Windows.Forms.Label label2;
		private System.Windows.Forms.ComboBox orderChoices;
		private ArrayList orderForms;
		private TabbedGroupedMDIManager tabbedMDIManager;
		private Syncfusion.Windows.Forms.Tools.GradientPanel gradientPanel1;
		private Syncfusion.Windows.Forms.Tools.GradientLabel gradientLabel1;
		private System.Windows.Forms.ImageList imageList1;
		private Syncfusion.Windows.Forms.Tools.GradientPanel gradientPanel2;
		private System.ComponentModel.IContainer components;

		public MainForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			// Initialize the forms list in the comboboxes.
			this.orderForms = new ArrayList(this.orderChoices.Items.Count);
			for(int i = 0; i < this.orderChoices.Items.Count; i++)
				this.orderForms.Add(null);

			// Initialize the tabbed MDI manager
			this.tabbedMDIManager = new TabbedGroupedMDIManager();
			this.tabbedMDIManager.TabControlAdded += new TabbedMDITabControlEventHandler(tabbedMDIManager_TabControlAdded);
			this.tabbedMDIManager.AllowTabGroupCustomizing = false;
			this.tabbedMDIManager.Horizontal = true;
			this.tabbedMDIManager.DropDownButtonVisible = true;
			this.tabbedMDIManager.BeforeDropDownPopup += new DropDownPopupEventHandler(tabbedMDIManager_BeforeDropDownPopup); 
			
			this.tabbedMDIManager.CloseItem.ImageList  = this.imageList1;
			this.tabbedMDIManager.ContextMenuItem.Style = Syncfusion.Windows.Forms.VisualStyle.Office2003;
			this.tabbedMDIManager.CloseItem.ImageIndex = 0;
			this.tabbedMDIManager.CloseButtonColor = Color.Blue;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(MainForm));
            this.splitter1 = new System.Windows.Forms.Splitter();
            this.panel1 = new System.Windows.Forms.Panel();
            this.gradientPanel1 = new Syncfusion.Windows.Forms.Tools.GradientPanel();
            this.gradientPanel2 = new Syncfusion.Windows.Forms.Tools.GradientPanel();
            this.orderChoices = new System.Windows.Forms.ComboBox();
            this.label2 = new System.Windows.Forms.Label();
            this.gradientLabel1 = new Syncfusion.Windows.Forms.Tools.GradientLabel();
            this.imageList1 = new System.Windows.Forms.ImageList(this.components);
            this.panel1.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.gradientPanel1)).BeginInit();
            this.gradientPanel1.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.gradientPanel2)).BeginInit();
            this.gradientPanel2.SuspendLayout();
            this.SuspendLayout();
            // 
            // splitter1
            // 
            this.splitter1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.splitter1.Location = new System.Drawing.Point(144, 0);
            this.splitter1.Name = "splitter1";
            this.splitter1.Size = new System.Drawing.Size(4, 417);
            this.splitter1.TabIndex = 2;
            this.splitter1.TabStop = false;
            // 
            // panel1
            // 
            this.panel1.Controls.Add(this.gradientPanel1);
            this.panel1.Dock = System.Windows.Forms.DockStyle.Left;
            this.panel1.Location = new System.Drawing.Point(0, 0);
            this.panel1.Name = "panel1";
            this.panel1.Size = new System.Drawing.Size(144, 417);
            this.panel1.TabIndex = 3;
            // 
            // gradientPanel1
            // 
            this.gradientPanel1.BackColor = System.Drawing.Color.White;
            this.gradientPanel1.BackgroundColor = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.Vertical, System.Drawing.Color.Transparent, System.Drawing.Color.Transparent);
            this.gradientPanel1.BorderColor = System.Drawing.Color.Black;
            this.gradientPanel1.BorderSingle = System.Windows.Forms.ButtonBorderStyle.None;
            this.gradientPanel1.BorderStyle = System.Windows.Forms.BorderStyle.None;
            this.gradientPanel1.Controls.Add(this.gradientPanel2);
            this.gradientPanel1.Controls.Add(this.gradientLabel1);
            this.gradientPanel1.Dock = System.Windows.Forms.DockStyle.Fill;
            this.gradientPanel1.Location = new System.Drawing.Point(0, 0);
            this.gradientPanel1.Name = "gradientPanel1";
            this.gradientPanel1.Size = new System.Drawing.Size(144, 417);
            this.gradientPanel1.TabIndex = 7;
            // 
            // gradientPanel2
            // 
            this.gradientPanel2.BackgroundColor = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.Vertical, System.Drawing.Color.FromArgb(((int)(((byte)(182)))), ((int)(((byte)(211)))), ((int)(((byte)(241))))), System.Drawing.Color.FromArgb(((int)(((byte)(219)))), ((int)(((byte)(229)))), ((int)(((byte)(241))))));
            this.gradientPanel2.Border3DStyle = System.Windows.Forms.Border3DStyle.SunkenOuter;
            this.gradientPanel2.BorderColor = System.Drawing.Color.Black;
            this.gradientPanel2.BorderStyle = System.Windows.Forms.BorderStyle.None;
            this.gradientPanel2.Controls.Add(this.orderChoices);
            this.gradientPanel2.Controls.Add(this.label2);
            this.gradientPanel2.Location = new System.Drawing.Point(8, 104);
            this.gradientPanel2.Name = "gradientPanel2";
            this.gradientPanel2.Size = new System.Drawing.Size(128, 168);
            this.gradientPanel2.TabIndex = 6;
            // 
            // orderChoices
            // 
            this.orderChoices.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.orderChoices.Items.AddRange(new object[] {
            "Order 1",
            "Order 2",
            "Order 3",
            "Order 4",
            "Order 5"});
            this.orderChoices.Location = new System.Drawing.Point(8, 128);
            this.orderChoices.Name = "orderChoices";
            this.orderChoices.Size = new System.Drawing.Size(112, 21);
            this.orderChoices.TabIndex = 3;
            this.orderChoices.SelectionChangeCommitted += new System.EventHandler(this.orderChoices_SelectedIndexChanged);
            // 
            // label2
            // 
            this.label2.BackColor = System.Drawing.Color.Transparent;
            this.label2.ForeColor = System.Drawing.SystemColors.ActiveCaptionText;
            this.label2.Location = new System.Drawing.Point(8, 88);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(112, 32);
            this.label2.TabIndex = 2;
            this.label2.Text = "Show Orders in Orders tab group:";
            // 
            // gradientLabel1
            // 
            this.gradientLabel1.BackgroundColor = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.Vertical, System.Drawing.Color.FromArgb(((int)(((byte)(182)))), ((int)(((byte)(211)))), ((int)(((byte)(241))))), System.Drawing.Color.FromArgb(((int)(((byte)(219)))), ((int)(((byte)(229)))), ((int)(((byte)(241))))));
            this.gradientLabel1.BorderSides = ((System.Windows.Forms.Border3DSide)(((((System.Windows.Forms.Border3DSide.Left | System.Windows.Forms.Border3DSide.Top)
                        | System.Windows.Forms.Border3DSide.Right)
                        | System.Windows.Forms.Border3DSide.Bottom)
                        | System.Windows.Forms.Border3DSide.Middle)));
            this.gradientLabel1.BorderStyle = System.Windows.Forms.Border3DStyle.SunkenOuter;
            this.gradientLabel1.Location = new System.Drawing.Point(8, 16);
            this.gradientLabel1.Name = "gradientLabel1";
            this.gradientLabel1.Size = new System.Drawing.Size(128, 64);
            this.gradientLabel1.TabIndex = 5;
            this.gradientLabel1.Text = "This sample shows you how to associate child forms to specifc tab groups.";
            this.gradientLabel1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // imageList1
            // 
            this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
            this.imageList1.TransparentColor = System.Drawing.Color.Transparent;
            this.imageList1.Images.SetKeyName(0, "");
            // 
            // MainForm
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(736, 417);
            this.Controls.Add(this.splitter1);
            this.Controls.Add(this.panel1);
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.IsMdiContainer = true;
            this.Name = "MainForm";
            this.Text = "Advanced TabbedMDI (Syncfusion Inc.)";
            this.Load += new System.EventHandler(this.MainForm_Load);
            this.panel1.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.gradientPanel1)).EndInit();
            this.gradientPanel1.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.gradientPanel2)).EndInit();
            this.gradientPanel2.ResumeLayout(false);
            this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new MainForm());
		}

		private void MainForm_Load(object sender, System.EventArgs e)
		{
			this.tabbedMDIManager.AttachToMdiContainer(this);
			// Specifiy the tab groups:
			this.tabbedMDIManager.TabbedGroups.Add(new TabbedGroup("Customers"));
			this.tabbedMDIManager.TabbedGroups.Add(new TabbedGroup("Orders"));

            CreateOrderInfoForm("test");
		}


		// Creating customer type child forms
		private CustomerInfoForm CreateCustomerInfoForm(string text)
		{
			CustomerInfoForm form = new CustomerInfoForm(text);

			// Add the CustomerInfoForm to a specific group.
			this.tabbedMDIManager.TabbedGroups["Customers"].AddForm(form);
			return form;
		}


		// Creating order type chid forms
		private Form1 CreateOrderInfoForm(string text)
		{
			Form1 form = new Form1();

			// Add the OrderInfoForm to a specific group.
			this.tabbedMDIManager.TabbedGroups["Orders"].AddForm(form);
			return form;
		}


		// User wanted to show a order form
		private void orderChoices_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			// Verify if a Form exists already...
			Form existingForm = this.orderForms[this.orderChoices.SelectedIndex] as Form;
			// Ensure that the Form is not disposed.
			if(existingForm != null && existingForm.IsDisposed)
			{
				this.orderForms[this.orderChoices.SelectedIndex] = null;
				existingForm = null;
			}

			// Create a new form if not already available.
			if(existingForm == null)
				this.orderForms[this.orderChoices.SelectedIndex]
					= this.CreateOrderInfoForm(this.orderChoices.SelectedItem.ToString());

			Form form = this.orderForms[this.orderChoices.SelectedIndex] as Form;
			form.Activate();
		}


		// Optionally, you can maximize a tab group when a child form gets activated by the user.
		protected override void OnMdiChildActivate(EventArgs e)
		{
			// Sometimes the tab host might be activated; ignore such cases.
			if(this.ActiveMdiChild != null && !(this.ActiveMdiChild is TabHost))
			{
				// Get the corresponding tab host.
				TabHost tabHost = this.tabbedMDIManager.GetTabHostFromForm(this.ActiveMdiChild);
				// If the group is "minimized" (weight 0) then,
				// make the group containing this Form occupy the maximum area.
				if(tabHost.MdiChildAutoScaleBaseDim == 0)
					this.tabbedMDIManager.MaximizeTabGroup(tabHost);
			}
			base.OnMdiChildActivate(e);
		}


		private void tabbedMDIManager_TabControlAdded(object sender, TabbedMDITabControlEventArgs args)
		{
			args.TabControl.TabStyle = typeof(TabRendererWhidbey);
			args.TabControl.ThemesEnabled = true;
			args.TabControl.TabPanelBackColor = Color.White;
			args.TabControl.TabGap =10;
		}

		
		private void tabbedMDIManager_BeforeDropDownPopup(object sender, DropDownPopupEventArgs e)
		{
            e.ParentBarItem.Style = Syncfusion.Windows.Forms.VisualStyle.Office2003;
		}	
	}
}
